require './helper'
Static.defaultHeaders['cache-control'] = 'Public'
Static.defaultHeaders['server']        = 'Node.js'

setup_server [
  Static "#{__dirname}/public", 
    default: 'index.html', 
    headers: 
      'cache-control': 'private'
  (req, res, next) ->
    res.writeHead 200
    res.end 'fallback'
], 5, ->

  assert.static_body 'served', '/index.html'
  assert.static '/index.html', (res) ->
    assert.equal 200, res.statusCode
    assert.equal 6, res.headers['content-length']
    assert.equal 'text/html', res.headers['content-type']
    assert.equal 'private',   res.headers['cache-control']
    assert.equal 'Node.js',   res.headers.server

  assert.static '/index.html', method: 'PUT', (res) ->
    assert.equal 405, res.statusCode

  assert.static '/index.html', method: 'HEAD', (res) ->
    res.on 'data', (chunk) ->
      throw new Error("No data should be sent for HEAD requests.")
    assert.equal 200, res.statusCode
    assert.equal 6, res.headers['content-length']
    assert.equal 'text/html', res.headers['content-type']

  assert.static_body 'fallback', '/../helper.coffee'